/*
 * WireProvider.java
 * (c) 2000  by Gerrit Gehnen <Gerrit.Gehnen@gmx.de>
 *
 * Created on 11. September 2000, 21:26
 */

package WireProvider;
import	java.util.ArrayList;
import	java.util.Vector;
import	java.util.Iterator;

import	javax.sound.midi.MidiDevice;
import	javax.sound.midi.spi.MidiDeviceProvider;


/**
 * @author Gerrit Gehnen
 * @version 0.1
 */
public class WireProvider extends javax.sound.midi.spi.MidiDeviceProvider {

  private static Vector m_devices;
  private static int maxin;
  private static int maxout;

   static MidiDevice.Info[] array; 

    static 
    {

        int i;
      	WireInput input;	// Single Objects for getting the number of devices
	WireOutput output;

       m_devices=new Vector();
//        System.out.println("Static block of WireProvider");
          	try { 

                WireNative testNative=new WireNative(0);  // Creates Objects simply for getting the numbers
                maxin=testNative.numberofdevices ();
                testNative=new WireNative(1);
                maxout=testNative.numberofdevices();

//  		System.out.println("Iterating "+maxin+" Inputs and "+maxout+" Outputs");
	 
          array= new MidiDevice.Info[maxin+maxout];   // Set the array so, that it can contain all elements

          for (i=0;i<maxin;i++)         // Adding all Inputs (with the Transmitters)
		{
		input=new WireInput();
		input.setport(i);
                m_devices.add(input);
                array[i]=input.getDeviceInfo();
                }
	 
            for ( i=0;i<maxout;i++)   // Adding all Outputs
		{
		output=new WireOutput();
		output.setport(i);
                m_devices.add(output);
                array[maxin+i]=output.getDeviceInfo();
                }
	    } catch(Exception e){e.printStackTrace ();}
  
//            System.out.println("Inputs: "+maxin+" Outputs: "+maxout);
  
  }
  /** Creates new WireProvider */
  public WireProvider () {
    
//    System.out.println("Konstruktor WireProvider");

  }

        /**
       * @return
       */
      public MidiDevice.Info[] getDeviceInfo ()
      {
//        System.out.println ("WireProvider: GetDeviceInfo");
        MidiDevice.Info[] info2=new MidiDevice.Info[array.length];
        System.arraycopy (array,0,info2,0,array.length);

        return info2;
      }



	/**
         * @param info
         * @return
         */
        public MidiDevice getDevice (MidiDevice.Info info)
        {
          Iterator	iterator = m_devices.iterator ();
          while (iterator.hasNext ())

          {
            MidiDevice	device = (MidiDevice) iterator.next ();
            MidiDevice.Info	info2 = device.getDeviceInfo ();
            if (info != null && info.equals (info2))

            {
              return device;
            }
          }
          throw new IllegalArgumentException ("no device for " + info);
        }

    
}
